//////////////////////////////////////////////////////////////////////
//     , 
//   8 
//////////////////////////////////////////////////////////////////////
#include "Gauge.h"

typedef unsigned(_stdcall *PTHREAD_START) (void *); //       -  
CRITICAL_SECTION g_cs; //   

int DelayOfThreadProc;

void Delay(void)
{
	for(int temp=0;temp<=DelayOfThreadProc;temp++){int g=(int)sqrt(1);}
};

TCHAR sz[255];	//      ListBox


class CThread  
{
public:
	CThread();
	virtual ~CThread();
	void Resume(void);	//       CREATE_SUSPENDED
	BOOL Create(TParams *pParam,CGauge *pGauge); //  
	void AddString(void);	//    ListBox
	BOOL m_Finished;		//   ?
	char m_OwnName;			//  
	char m_ParentName;		//  
	int  m_Lenght;			//   ()
private:
	HANDLE	m_hThread;		//  () 
	DWORD	m_dwThreadID;	//   
	int		m_Priority;		//  
	CGauge *m_pgauge; //   ,        
protected:
	virtual void Finish(void); //    (   )
	void Execute(void);			//    (   )
	static  DWORD WINAPI ThreadProc(LPVOID instance);	//       
														//     static
};

CThread Thread;


//////////////////////////////////////////////
//  
//////////////////////////////////////////////
CThread::CThread()
{
}


CThread::~CThread()
{
}

void CThread::AddString(void)
{
	wsprintf(sz,TEXT(" %c "),m_OwnName);
	SendMessage(hListBox,LB_ADDSTRING,0,(LPARAM)DupString(sz)); //    ListBox
	return;
}

void CThread::Finish(void)
{
	return;
}

void CThread::Execute(void)
{
	wsprintf(sz,TEXT("  %c  %c"),m_OwnName,m_ParentName);
	SendMessage(hListBox,LB_ADDSTRING,0,(LPARAM)DupString(sz));
	
	m_pgauge->OnPaint();
	for(int i=0;i<=100;i++)
	{
		m_pgauge->m_Progress=i;
	   	m_pgauge->OnDraw();

		switch(m_Lenght)
		{
		case 3: Delay();
		case 2: Delay();
		case 1: Delay();
		}
	}
	Finish();

	m_pgauge->m_Enabled=FALSE;
	m_pgauge->m_Progress=0;
	m_pgauge->OnPaint();
	return;
}


//  
void CThread::Resume(void)
{
	m_pgauge->m_Enabled=TRUE;
	ResumeThread(m_hThread);
	CloseHandle(m_hThread);
	return;
}


// instance -  ()   CThread  
DWORD CThread::ThreadProc(LPVOID instance)
{
	DWORD dwResult=0;
	((CThread *)instance)->Execute();
	return(dwResult);
}



//  
BOOL CThread::Create(TParams *pParam,CGauge *pGauge)
{
	//   
	m_Finished=FALSE;
	m_pgauge=pGauge;

	m_ParentName = pParam->ParentName;
	m_OwnName	 = pParam->OwnName;
	m_Lenght	 = pParam->Length;
	
	
	//   
	//  CREATE_SUSPENDED   ,     
	//       - 

	//  _beginthreadex    process.h
	//  ++   ,   CreateThread
	m_hThread=(HANDLE)_beginthreadex(NULL,0,(PTHREAD_START)ThreadProc,(LPVOID)this,CREATE_SUSPENDED,(unsigned *)&m_dwThreadID);


	//  
	int nBuffer= pParam->ZType*100+pParam->Priority;

	if ((100<=nBuffer)&&(nBuffer<=105)) m_Priority=THREAD_PRIORITY_TIME_CRITICAL;
	else 
		if((106<=nBuffer)&&(nBuffer<=110)) m_Priority=THREAD_PRIORITY_HIGHEST;
		else 
			if((111<=nBuffer)&&(nBuffer<=115)) m_Priority=THREAD_PRIORITY_ABOVE_NORMAL;
			else 
				if((116<=nBuffer)&&(nBuffer<=200)) m_Priority=THREAD_PRIORITY_NORMAL;
				else 
					if((201<=nBuffer)&&(nBuffer<=300)) m_Priority=THREAD_PRIORITY_BELOW_NORMAL;
					else 
						if((301<=nBuffer)&&(nBuffer<=399)) m_Priority=THREAD_PRIORITY_LOWEST;
						else m_Priority=THREAD_PRIORITY_IDLE;
    SetThreadPriority(m_hThread,m_Priority);
	return TRUE;
}





