//////////////////////////////////////////////
//         
//       CThrear 
//       Finish().
//////////////////////////////////////////////
#include "Thread.h"


class CThreadA : public CThread  
{
protected:
	void Finish(void);
};


class CThreadB : public CThread  
{
protected:
	void Finish(void);
};


class CThreadC : public CThread  
{
protected:
	void Finish(void);
};

class CThreadD : public CThread  
{
protected:
	void Finish(void);
};


class CThreadE : public CThread  
{
protected:
	void Finish(void);
};

class CThreadG : public CThread  
{
protected:
	void Finish(void);
};


class CThreadH : public CThread  
{
protected:
	void Finish(void);
};


class CThreadI : public CThread  
{
protected:
	void Finish(void);
};


////////////////////////////////////////
//    
////////////////////////////////////////
CThreadA ThreadA;
CThreadB ThreadB;
CThreadC ThreadC;
CThreadD ThreadD;
CThreadE ThreadE;
CThreadG ThreadG;
CThreadH ThreadH;
CThreadI ThreadI;


void CThreadA::Finish(void)
{
	ThreadC.Resume();
	ThreadD.Resume();

	AddString();
	wsprintf(sz,TEXT("(  C  D  %c)"),m_OwnName);
	SendMessage(hListBox,LB_ADDSTRING,0,(LPARAM)DupString(sz));
		
	m_Finished=TRUE;
	return;
}

void CThreadB::Finish(void)
{
	m_Finished=TRUE;
	
	EnterCriticalSection(&g_cs);
	__try 
	{
			AddString();
			if(ThreadC.m_Finished)
			{
				ThreadE.m_ParentName='B';
				ThreadE.Resume();
				ThreadH.m_ParentName='B';
				ThreadH.Resume();

				wsprintf(sz,TEXT("(  E  H  %c)"),m_OwnName);
				SendMessage(hListBox,LB_ADDSTRING,0,(LPARAM)DupString(sz));
			}
	}
	__finally 
	{
		LeaveCriticalSection(&g_cs);

	}
	return;
}

void CThreadC::Finish(void)
{
	m_Finished=TRUE;	

	EnterCriticalSection(&g_cs);
	__try 
	{
		AddString();
		if(ThreadB.m_Finished)
		{
			ThreadE.m_ParentName='C';
			ThreadE.Resume();
			ThreadH.m_ParentName='C';
			ThreadH.Resume();
	
			wsprintf(sz,TEXT("(  E  H  %c)"),m_OwnName);
			SendMessage(hListBox,LB_ADDSTRING,0,(LPARAM)DupString(sz));
		}
	}
	__finally 
	{
		LeaveCriticalSection(&g_cs);
	}
	
	return;
}

void CThreadD::Finish(void)
{
	m_Finished=TRUE;	

	EnterCriticalSection(&g_cs);
	__try 
	{
		AddString();
		if(ThreadE.m_Finished)
		{
			ThreadG.m_ParentName='D';
			ThreadG.Resume();
			
			wsprintf(sz,TEXT("(  G  %c)"),m_OwnName);
			SendMessage(hListBox,LB_ADDSTRING,0,(LPARAM)DupString(sz));
		}
	}
	__finally
	{
		LeaveCriticalSection(&g_cs);
	}
	
	return;
}

void CThreadE::Finish(void)
{
	m_Finished=TRUE;	

	EnterCriticalSection(&g_cs);
	__try 
	{
		AddString();
		if(ThreadD.m_Finished)
		{
			ThreadG.m_ParentName='E';
			ThreadG.Resume();

			wsprintf(sz,TEXT("(  G  %c)"),m_OwnName);
			SendMessage(hListBox,LB_ADDSTRING,0,(LPARAM)DupString(sz));
		}
	}
	__finally
	{
		LeaveCriticalSection(&g_cs);
	}
	
	return;
}

void CThreadG::Finish(void)
{
	m_Finished=TRUE;	

	EnterCriticalSection(&g_cs);
	__try 
	{
		AddString();
		if(ThreadH.m_Finished)
		{
			ThreadI.m_ParentName='G';
			ThreadI.Resume();

			wsprintf(sz,TEXT("(  I  %c)"),m_OwnName);
			SendMessage(hListBox,LB_ADDSTRING,0,(LPARAM)DupString(sz));
		}
	}
	__finally
	{
		LeaveCriticalSection(&g_cs);
	}
	
	return;
}


void CThreadH::Finish(void)
{
	m_Finished=TRUE;	

	EnterCriticalSection(&g_cs);
	__try 
	{
		AddString();
		if(ThreadG.m_Finished)
		{
			ThreadI.m_ParentName='H';
			ThreadI.Resume();

			wsprintf(sz,TEXT("(  I  %c)"),m_OwnName);
			SendMessage(hListBox,LB_ADDSTRING,0,(LPARAM)DupString(sz));
		}
	}
	__finally 
	{
		LeaveCriticalSection(&g_cs);
	}
	return;
}

void CThreadI::Finish(void)
{
	m_Finished=TRUE;

	EnterCriticalSection(&g_cs);
	__try 
	{
		IsPush=FALSE; //     ""
		AddString();

		FILE* fp=fopen("task.log","wt");
		fprintf(fp,"------    ------");
		
		int nCount=SendMessage(hListBox,LB_GETCOUNT,0,0);
		for(int i=0;i<=nCount;i++)
		{
			SendMessage(hListBox,LB_GETTEXT,(WPARAM)i,(LPARAM)sz);
			fprintf(fp,"\n%s",sz);

		}
		fclose(fp);
	}
	__finally 
	{
		LeaveCriticalSection(&g_cs);
	}

	return;
}


